
'===========================================================================
' GENERIC.BAS
'
' Create generic features
'===========================================================================
'
' Global variables
'
Option Explicit
'
Dim FocusedControl As String
Dim LastFocus As Integer
Dim FeatureType As Integer
Dim SelFeatCoordID As String
Dim SelFeatVectID As String
Dim FeatureList(9999) As String
'
Dim PCDApp As Object, PCDPartPrograms As Object, PCDPartProgram As Object, PCDCommands As Object, PCDCommand As Object
Dim PCDFeatCmd As Object, PCDVectCmd As Object
'
Dim vTX As Double, vTY As Double, vTZ As Double, vTI As Double, vTJ As Double, vTK As Double
Dim vX As Double, vY As Double, vZ As Double, vI As Double, vJ As Double, vK As Double
'
Dim dummy As Boolean
'
' Dialog handling
'
Function Events(ControlID$, Action%, SuppValue%)
  Events = 99 ' Don't Close Dialog, just continue
    '
   Select Case Action%
    '
    Case 1  '  Before Dialog is visible, hide some controls ("Point" assumed)
        '
        DlgEnable "lbOutIn", 0
        DlgVisible "lbOutIn", 0
        DlgEnable "edAngle", 0
        DlgEnable "edDistance", 0
        DlgEnable "edRadDiam", 0
        DlgEnable "edBoth", 0
        DlgEnable "edValueRef", 0
    '
    Case 2  '  Button pushed, checkbox checked, etc. ControlID$, SuppValue%
         '
         ' For some reason, the radio buttons 'Name' starts With a quote character!?
        If Left(ControlID$, 1) = chr(34) Then
          ' Radio button, but which one? There's no way To Get the group Name, so we have To check the actual text If we have more than one
          ' group, And we can't actually differentiate If two groups have the same text somewhere :-(
          '
          ' Solution: Eliminate all radio groups but one, making combo boxes of the others - done!
          '
          ' activate/deactivate appropriate fields, depending On which radio button was clicked
          '
          FeatureType = SuppValue%
          Select Case FeatureType
          '
            Case 0, 1  '  Point, Plane
              DlgVisible "lbOutIn", 0
              DlgEnable "lbOutIn", 0
              DlgEnable "edAngle", 0
              DlgEnable "edDistance", 0
              DlgEnable "edRadDiam", 0
              ' IJK1/IJK2 invisible, disabled
            '
            Case 2  '  Line
              DlgVisible "lbOutIn", 0
              DlgEnable "lbOutIn", 0
              DlgEnable "edAngle", 0
              DlgEnable "edDistance", 1
              DlgEnable "edRadDiam", 0
              ' IJK1/IJK2 invisible, disabled
            '
            Case 3  '  None
              DlgVisible "lbOutIn", 0
              DlgEnable "lbOutIn", 0
              DlgEnable "edAngle", 1
              DlgEnable "edDistance", 1
              DlgEnable "edRadDiam", 1
              ' IJK1/IJK2 invisible, disabled
            '
            Case 4, 5  '  Circle, Sphere
              DlgVisible "lbOutIn", 1
              DlgEnable "lbOutIn", 1
              DlgEnable "edAngle", 0
              DlgEnable "edDistance", 0
              DlgEnable "edRadDiam", 1
              ' IJK1/IJK2 invisible, disabled
            '
            Case 6  '  Cylinder
              DlgVisible "lbOutIn", 1
              DlgEnable "lbOutIn", 1
              DlgEnable "edAngle", 0
              DlgEnable "edDistance", 1
              DlgEnable "edRadDiam", 1
              ' IJK1/IJK2 invisible, disabled
            '
            Case 7, 8  '  Round slot, Square slot
              DlgVisible "lbOutIn", 1
              DlgEnable "lbOutIn", 1
              DlgEnable "edAngle", 0
              DlgEnable "edDistance", 1
              DlgEnable "edRadDiam", 1
              ' IJK1/IJK2 visible, enabled 
            '
            Case 9  '  Cone
              DlgVisible "lbOutIn", 1
              DlgEnable "lbOutIn", 1
              DlgEnable "edAngle", 1
              DlgEnable "edDistance", 1
              DlgEnable "edRadDiam", 0
              ' IJK1/IJK2 invisible, disabled
            '
          End Select
            '
        Elseif  Left(ControlID$, 2) = "lb" Then
          '
          If ControlID$ = "lbSelFeatCoord" Then
            '
            ' feature coordinate selection list
            '
            SelFeatCoordID = FeatureList(SuppValue% + 1)
            DlgText "edX", SelFeatCoordID + ".X"
            DlgText "edY", SelFeatCoordID + ".Y"
            DlgText "edZ", SelFeatCoordID + ".Z"
            '
            SelFeatVectID = SelFeatCoordID
            DlgText "edI", SelFeatVectID + ".I"
            DlgText "edJ", SelFeatVectID + ".J"
            DlgText "edK", SelFeatVectID + ".K"
            '
          ElseIf ControlID$ = "lbSelFeatVect" Then
            '
            ' feature vector selection list
            '
            SelFeatVectID = FeatureList(SuppValue% + 1)
            DlgValue "lbValueRef", 2
            DlgText "edI", SelFeatVectID + ".I"
            DlgText "edJ", SelFeatVectID + ".J"
            DlgText "edK", SelFeatVectID + ".K"
            ' If XYZ-Select, Set IJK To the same feature. If IJK-Select, only change IJK
            ' Not implemented yet
            '
          Else
            '
            ' other listboxes And comboboxes, Nothing To Do now - values may be Read later when generating
            '
          End If
          '
        Else ' buttons
          '
          ' Note: ControlID$ is wrong For buttons!!! And we need To check edFeatName If OK pressed
          '
          If ControlID$ = "Cancel" Then ' Yes, this is the OK button !!!
            If DlgText("edFeatName") <> "" Then
              Events = 0  '  OK To leave
            Else
              MsgBox "You must enter a name for the feature!"
            End If
          Else
            Events = 0 ' Leave Dialog,
          End If
          '
        End If
    '
    Case 3  '  Change detected (Help doesn't seem To be correct here - gets called directly when a character changes In an Edit box)
        If Left(ControlID$, 2) = "ed" Then
          ' Nothing To Do
        Else
          ' Nothing To Do - don't even know what events would Get here...
        End If
    '
    Case 4  '  Focus change, ControlID$ tells which control will Get focused, SuppValue% numid of control losing it. No MsdgBox Or Dlg here!
        ' don't know what use it can have...
        FocusedControl = ControlID$
        LastFocus = SuppValue%
        ' DlgText "edFeatName", ControlID$+",  "+ Str$(SuppValue%)            ' debug
  End Select
  '
End Function

Sub Main()

Set PCDApp = CreateObject("PCDLRN.Application")
Set PCDPartPrograms = PCDApp.PartPrograms
Set PCDPartProgram = PCDApp.ActivePartProgram
Set PCDCommands = PCDPartProgram.Commands
Dim cmd As Object
Dim FeatCmd As Object

Dim NumFeat As Integer
Dim FeatTypes(10) As String
Dim TypeNums(10) As Integer

Dim retval As Integer
Dim pName As String

Dim OutIn$(2)
Dim RectPol$(2)
Dim RadDiam$(2)
Dim DepInd$(2)
Dim DlgResult As Integer
Dim cDlgCancel As Integer
Dim cDlgOK As Integer

cDlgCancel = 0
cDlgOK = -1
'
'***** Predialog START
'
FeatureList(1) = "(none)"
NumFeat = 2
' Enumerate commands
For Each cmd In PCDCommands
' Measured (learned) feature
  If cmd.IsMeasuredFeature Then 
    FeatureList(NumFeat) = cmd.ID
    NumFeat = NumFeat + 1
  End If
' Autofeature (flagged As DCC feature)
  If cmd.IsDCCFeature Then
    FeatureList(NumFeat) = cmd.ID
    NumFeat = NumFeat + 1
  End If
' Constructed feature
  If cmd.IsConstructedFeature Then
    FeatureList(NumFeat) = cmd.ID
    NumFeat = NumFeat + 1
  End If
Next cmd
'
OutIn$(1) = "OUT"
OutIn$(2) = "IN"
'
RectPol$(1) = "RECT"
RectPol$(2) = "POLAR"
'
RadDiam$(1) = "DIAMETER"
RadDiam$(2) = "RADIUS"
'
DepInd$(1) = "DEPENDENT"
DepInd$(2) = "INDEPENDENT"
'
SelFeatCoordID = "(none)"
SelFeatVectID = "(none)"
'
FeatTypes(1) = "POINT"
FeatTypes(2) = "PLANE"
FeatTypes(3) = "LINE"
FeatTypes(4) = "NONE"
FeatTypes(5) = "CIRCLE"
FeatTypes(6) = "SPHERE"
FeatTypes(7) = "CYLINDER"
FeatTypes(8) = "ROUND_SLOT"
FeatTypes(9) = "SQUARE_SLOT"
FeatTypes(10) = "CONE"

TypeNums(1) = GENERIC_POINT
TypeNums(2) = GENERIC_PLANE
TypeNums(3) = GENERIC_LINE
TypeNums(4) = GENERIC_NONE
TypeNums(5) = GENERIC_CIRCLE
TypeNums(6) = GENERIC_SPHERE
TypeNums(7) = GENERIC_CYLINDER
TypeNums(8) = GENERIC_ROUND_SLOT
TypeNums(9) = GENERIC_SQUARE_SLOT
TypeNums(10) = GENERIC_CONE

'***** Dialog START

Begin Dialog DLGGENFEAT -1,46, 260, 242, "Construct Generic Feature", .Events
  Text 4,4,61,12, "Feature name:"
  TextBox 68,4,112,12, .edFeatName
  OptionGroup .GRPFEATURE
    OptionButton 8,40,37,12, "Point"
    OptionButton 8,56,37,12, "Plane"
    OptionButton 8,72,37,12, "Line"
    OptionButton 8,88,37,12, "None"
    OptionButton 56,40,37,12, "Circle"
    OptionButton 56,56,37,12, "Sphere "
    OptionButton 56,72,49,12, "Cylinder "
    OptionButton 108,40,53,12, "Round Slot"
    OptionButton 108,56,53,12, "Square Slot"
    OptionButton 108,72,37,12, "Cone"
  GroupBox 4,24,160,84, "Feature type"
  DropListBox 176,28,69,12, OutIn$(), .lbOutIn
  DropListBox 176,48,69,12, RectPol$(), .lbRectPol
  Text 176,64,37,12, "Angle:"
  TextBox 176,76,69,12, .edAngle
  Text 176,92,37,12, "Distance:"
  TextBox 176,104,69,12, .edDistance
  Text 8,148,13,12, "X:"
  TextBox 20,148,52,12, .edX
  Text 8,168,13,12, "Y:"
  TextBox 20,168,52,12, .edY
  Text 8,188,13,12, "Z:"
  TextBox 20,188,52,12, .edZ
  Text 80,148,13,12, "I:"
  TextBox 92,148,52,12, .edI
  Text 80,168,13,12, "J:"
  TextBox 92,168,52,12, .edJ
  Text 80,188,13,12, "K:"
  TextBox 92,188,52,12, .edK
  TextBox 176,148,68,12, .edRadDiam
  DropListBox 20,212,52,12, FeatureList$(), .lbSelFeatCoord
  DropListBox 92,212,52,12, FeatureList$(), .lbSelFeatVect
  DropListBox 176,168,68,12, DepInd$(), .lbDepInd
  CancelButton 208,212,36,16
  OKButton 164,212,36,16
  DropListBox 176,128,68,12, RadDiam$(), .lbRadDiam
  Text 4,128,20,12, "Set:"
  TextBox 20,128,53,12, .edBoth
  TextBox 176,188,69,12, .edValueRef
End Dialog
'
Dim Dlg1 As DLGGENFEAT
'
FeatureType = 0 ' Point
Dlg1.edBoth = "BOTH"
Dlg1.edValueRef = "REFERENCE"
Dlg1.edFeatName = "F1"
'
DlgResult = Dialog(Dlg1)
' button 0 = Cancel, -1 = OK

If (DlgResult = cDlgOK) Then
   
  ' Create Generic feature
  Set cmd = PCDCommands.Add(GENERIC_CONSTRUCTION, True)
  Set FeatCmd = cmd.FeatureCommand

  cmd.ID = Dlg1.edFeatName

  FeatCmd.GenericType = TypeNums(FeatureType+1)

  cmd.Marked = True

  FeatCmd.Polar = (Dlg1.lbRectPol = 1) ' 0 - CARTESIAN, 1 - POLAR
  FeatCmd.GenericAlignMode = Dlg1.lbDepInd ' 0 - DEPENDENT, 1 - INDEPENDENT
  
  If (FeatureType >= 4) Then ' Circle, Sphere, Cylinder, Round Slot, Square Slot, Cone
    FeatCmd.Inner = (Dlg1.lbOutIn = 1)
  End If

  If (FeatureType = 3) Or (FeatureType = 9) Then ' None, Cone
    retval = cmd.SetExpression (Dlg1.edAngle, THEO_ANGLE, 0)
    retval = cmd.SetExpression (Dlg1.edAngle, MEAS_ANGLE, 0)
  End If

  If (FeatureType = 2) Or (FeatureType = 3) Or ((FeatureType >= 6) And (FeatureType <= 9)) Then ' Line, None, Cylinder, Round Slot, Square Slot, Cone
    retval = cmd.SetExpression (Dlg1.edDistance, THEO_LENGTH, 0)
    retval = cmd.SetExpression (Dlg1.edDistance, MEAS_LENGTH, 0)
  End If

  If (FeatureType >= 3) And (FeatureType <= 8) Then ' None, Circle, Sphere, Cylinder, Round Slot, Square Slot
    If Dlg1.lbRadDiam = 0 Then ' Diameter
      FeatCmd.GenericDisplayMode = GENERIC_DISPLAY_DIAMETER
      retval = cmd.SetExpression (Dlg1.edRadDiam, THEO_DIAM, 0)
      retval = cmd.SetExpression (Dlg1.edRadDiam, MEAS_DIAM, 0)
    Else
      FeatCmd.GenericDisplayMode = GENERIC_DISPLAY_RADIUS
      retval = cmd.SetExpression (Dlg1.edRadDiam, THEO_RADIUS, 0)
      retval = cmd.SetExpression (Dlg1.edRadDiam, MEAS_RADIUS, 0)
    End If
  End If

  If SelFeatCoordID = "(none)" Then
    If Dlg1.lbRectPol = 0 Then ' CARTESIAN
      retval = cmd.SetExpression (Dlg1.edX, THEO_X, 0)
      retval = cmd.SetExpression (Dlg1.edY, THEO_Y, 0)
      retval = cmd.SetExpression (Dlg1.edZ, THEO_Z, 0)
      retval = cmd.SetExpression (Dlg1.edX, MEAS_X, 0)
      retval = cmd.SetExpression (Dlg1.edY, MEAS_Y, 0)
      retval = cmd.SetExpression (Dlg1.edZ, MEAS_Z, 0)
    Else ' POLAR
      retval = cmd.SetExpression (Dlg1.edX, THEO_R, 0)
      retval = cmd.SetExpression (Dlg1.edY, THEO_A, 0)
      retval = cmd.SetExpression (Dlg1.edZ, THEO_H, 0)
      retval = cmd.SetExpression (Dlg1.edX, MEAS_R, 0)
      retval = cmd.SetExpression (Dlg1.edY, MEAS_A, 0)
      retval = cmd.SetExpression (Dlg1.edZ, MEAS_H, 0)
    End If
  Else
    pname = SelFeatCoordID
    If Dlg1.lbRectPol = 0 Then ' CARTESIAN
      retval = cmd.SetExpression (pName & ".TX", THEO_X, 0)
      retval = cmd.SetExpression (pName & ".TY", THEO_Y, 0)
      retval = cmd.SetExpression (pName & ".TZ", THEO_Z, 0)
      retval = cmd.SetExpression (pName & ".X", MEAS_X, 0)
      retval = cmd.SetExpression (pName & ".Y", MEAS_Y, 0)
      retval = cmd.SetExpression (pName & ".Z", MEAS_Z, 0)
    Else ' POLAR
      retval = cmd.SetExpression (pName & ".TPR", THEO_R, 0)
      retval = cmd.SetExpression (pName & ".TPA", THEO_A, 0)
      retval = cmd.SetExpression (pName & ".TPH", THEO_H, 0)
      retval = cmd.SetExpression (pName & ".PR", MEAS_R, 0)
      retval = cmd.SetExpression (pName & ".PA", MEAS_A, 0)
      retval = cmd.SetExpression (pName & ".PH", MEAS_H, 0)
    End If
  End If

  If SelFeatVectID = "(none)" Then
    If SelFeatCoordID = "(none)" Then
      retval = cmd.SetExpression (Dlg1.edI, THEO_I, 0)
      retval = cmd.SetExpression (Dlg1.edJ, THEO_J, 0)
      retval = cmd.SetExpression (Dlg1.edK, THEO_K, 0)
      retval = cmd.SetExpression (Dlg1.edI, MEAS_I, 0)
      retval = cmd.SetExpression (Dlg1.edJ, MEAS_J, 0)
      retval = cmd.SetExpression (Dlg1.edK, MEAS_K, 0)         
    End If
  Else
    pname = SelFeatVectID
    retval = cmd.SetExpression (pName & ".TI", THEO_I, 0)
    retval = cmd.SetExpression (pName & ".TJ", THEO_J, 0)
    retval = cmd.SetExpression (pName & ".TK", THEO_K, 0)
    retval = cmd.SetExpression (pName & ".I", MEAS_I, 0)
    retval = cmd.SetExpression (pName & ".J", MEAS_J, 0)
    retval = cmd.SetExpression (pName & ".K", MEAS_K, 0)
  End If

  PCDPartProgram.RefreshPart
  cmd.ReDraw
    
  '***** Cleanup
  Set PCDCommand = Nothing
  Set PCDCommands = Nothing
  Set PCDPartProgram = Nothing
  Set PCDPartPrograms = Nothing
  Set PCDApp = Nothing
  '*****
End If 
End Sub
